Module | Forwardable
In: | forwardable.rb

The Forwardable module provides delegation of specified methods to a designated object, using the methods def_delegator and def_delegators.

For example, say you have a class RecordCollection which contains an array `@records`. You could provide the lookup method record_number(), which simply calls #[] on the `@records` array, like this:

      class RecordCollection
        extends Forwardable
        def_delegator :@records, :[], :record_number
      end

Further, if you wish to provide the methods size, #<<, and map, all of which delegate to @records, this is how you can do it:

      class RecordCollection
        # extends Forwardable, but we did that above
        def_delegators :@records, :size, :<<, :map
      end

Also see the example at forwardable.rb.

### Methods

def_delegator def_delegators def_instance_delegator def_instance_delegators

### Attributes

debug | [RW] | force Forwardable to show up in stack backtraces of delegated methods

### Public Instance methods

def_delegator(accessor, method, ali = method)

Alias for def_instance_delegator

def_delegators(accessor, *methods)

Alias for def_instance_delegators

def_instance_delegator(accessor, method, ali = method)

Defines a method method which delegates to obj (i.e. it calls the method of the same name in obj). If new_name is provided, it is used as the name for the delegate method.

See the examples at Forwardable and forwardable.rb.

[Source]

    # File forwardable.rb, line 143
      def def_instance_delegator(accessor, method, ali = method)
        accessor = accessor.id2name if accessor.kind_of?(Integer)
        method = method.id2name if method.kind_of?(Integer)
        ali = ali.id2name if ali.kind_of?(Integer)

        module_eval("def \#{ali}(*args, &block)\nbegin\n\#{accessor}.__send__(:\#{method}, *args, &block)\nrescue Exception\n$@.delete_if{|s| /^\\\\(__FORWARDABLE__\\\\):/ =~ s} unless Forwardable::debug\nKernel::raise\nend\nend\n", "(__FORWARDABLE__)", 1)
      end

def_instance_delegators(accessor, *methods)

Shortcut for defining multiple delegator methods, but with no provision for using a different name. The following two code samples have the same effect:

      def_delegators :@records, :size, :<<, :map

      def_delegator :@records, :size
      def_delegator :@records, :<<
      def_delegator :@records, :map

See the examples at Forwardable and forwardable.rb.

[Source]

    # File forwardable.rb, line 130
      def def_instance_delegators(accessor, *methods)
        for method in methods
          def_instance_delegator(accessor, method)
        end
      end

[Validate]